package com.its.op.service.its.vms;

import com.its.op.dao.repository.its.vms.TbVmsFormObjectRepository;
import com.its.op.dao.repository.its.vms.TbVmsSymbLibRepository;
import com.its.op.dto.its.common.NewIdIntegerDto;
import com.its.op.dto.its.common.UsageCountDto;
import com.its.op.dto.its.vms.TbVmsSymbLibDto;
import com.its.op.entity.its.vms.TbVmsSymbLib;
import com.its.utils.ItsUtils;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
public class TbVmsSymbLibService {

    private final String SYMB_TYPE;
    private final Integer minNmbr;
    private final Integer maxNmbr;
    private final TbVmsSymbLibRepository repo;
    private final TbVmsFormObjectRepository formObjectRepository;

    public TbVmsSymbLibService(String symbType, Integer minNmbr, Integer maxNmbr, TbVmsSymbLibRepository repo, TbVmsFormObjectRepository formObjectRepository) {
        this.SYMB_TYPE = symbType;
        this.minNmbr = minNmbr;
        this.maxNmbr = maxNmbr;
        this.repo = repo;
        this.formObjectRepository = formObjectRepository;
    }

    // 데이터 1건 조회, 없으면 exception
    public TbVmsSymbLib requireOne(Integer id) throws NoSuchElementException {
        Optional<TbVmsSymbLib> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
    }

    /**
     * 심볼유형에 따른 이미지 심볼 데이터 조회
     * @return
     */
    public List<TbVmsSymbLibDto> findAllSymbolImage() {

        String saveDir = ItsUtils.createUserDir("/image/vms/");
        List<TbVmsSymbLibDto> result = new ArrayList<>();
        List<TbVmsSymbLib> data = this.repo.findAllSymbolImage(this.SYMB_TYPE);
        if (data != null) {
            data.forEach(obj -> {
                result.add(obj.toDto());
                //ItsUtils.saveByteArrayToFile(saveDir + obj.getSymbLibNmbr() + ".bmp", obj.getImagData());
            });
        }
        return result;
    }

    // 전체 데이터 조회
    public List<TbVmsSymbLibDto> findAll() {
        List<TbVmsSymbLibDto> result = new ArrayList<>();
        List<TbVmsSymbLib> data = this.repo.findAll();
        for (TbVmsSymbLib entity : data) {
            if (entity.getSymbType() != null && this.SYMB_TYPE.equals(entity.getSymbType())) {
                result.add(entity.toDto());
            }
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    public TbVmsSymbLibDto findById(Integer id) {
        TbVmsSymbLib entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    public TbVmsSymbLibDto updateById(Integer id, TbVmsSymbLibDto.TbVmsSymbLibUpdReq req) {
        TbVmsSymbLib entity = requireOne(id);
        req.setSymbType(this.SYMB_TYPE);
        if (req.getRgstDt() == null) req.setRgstDt(ItsUtils.getSysTime());   // 현재시각으로 업데이트
        req.setUpdtDt(ItsUtils.getSysTime());   // 현재시각으로 업데이트
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    public List<TbVmsSymbLibDto> mergeInfoList(List<TbVmsSymbLibDto.TbVmsSymbLibUpdReq> reqList) {
        List<TbVmsSymbLibDto> result = new ArrayList<>();
        for (TbVmsSymbLibDto.TbVmsSymbLibUpdReq req : reqList) {
            req.setSymbType(this.SYMB_TYPE);
            if (req.getRgstDt() == null) req.setRgstDt(ItsUtils.getSysTime());   // 현재시각으로 업데이트
            req.setUpdtDt(ItsUtils.getSysTime());   // 현재시각으로 업데이트
            TbVmsSymbLib obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    public TbVmsSymbLibDto mergeInfo(TbVmsSymbLibDto.TbVmsSymbLibUpdReq req) {
        req.setSymbType(this.SYMB_TYPE);
        if (req.getDelYn() == null) {
            req.setDelYn("N");
        }
        if (req.getRgstDt() == null) req.setRgstDt(ItsUtils.getSysTime());   // 현재시각으로 업데이트
        req.setUpdtDt(ItsUtils.getSysTime());   // 현재시각으로 업데이트
        TbVmsSymbLib obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    public TbVmsSymbLibDto deleteById(Integer id) {
        TbVmsSymbLib entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    public List<TbVmsSymbLibDto> deleteByIds(List<Integer> ids) {
        List<TbVmsSymbLibDto> result = new ArrayList<>();
        for (Integer id : ids) {
            Optional<TbVmsSymbLib> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    public UsageCountDto findUsageCountBySymbolId(Integer id) {
        UsageCountDto result = UsageCountDto.builder()
                .count(0)
                .build();
        Integer data = this.formObjectRepository.findUsageCountBySymbolId(id);
        result.setCount(data);
        return result;
    }

    public NewIdIntegerDto getNewSymbolId() {
        NewIdIntegerDto result = NewIdIntegerDto.builder()
                .newId(0)
                .build();
        Integer data = this.repo.getNewSymbolId(this.minNmbr, this.maxNmbr);
        result.setNewId(data);
        return result;
    }
}
